commit 8543d0d96fdac6b0ee30ef22a8def57fba30f9a2
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Fri Jan 25 14:38:57 2019 +0100

    Cleanup of the STM32L4 module.
    Applied several recent changes in AMiRo-OS to this module.

diff --git a/modules/RT-STM32L476RG-NUCLEO64/halconf.h b/modules/RT-STM32L476RG-NUCLEO64/halconf.h
index 37ccfc5..18d9dc3 100644
--- a/modules/RT-STM32L476RG-NUCLEO64/halconf.h
+++ b/modules/RT-STM32L476RG-NUCLEO64/halconf.h
@@ -1,32 +1,34 @@
 /*
-    ChibiOS - Copyright (C) 2006..2017 Giovanni Di Sirio
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
-    Licensed under the Apache License, Version 2.0 (the "License");
-    you may not use this file except in compliance with the License.
-    You may obtain a copy of the License at
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
 
-        http://www.apache.org/licenses/LICENSE-2.0
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
 
-    Unless required by applicable law or agreed to in writing, software
-    distributed under the License is distributed on an "AS IS" BASIS,
-    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-    See the License for the specific language governing permissions and
-    limitations under the License.
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 /**
- * @file    templates/halconf.h
- * @brief   HAL configuration header.
+ * @file    
+ * @brief   HAL configuration header for the STM32L476RG-NUCLEO64 module.
  * @details HAL configuration file, this file allows to enable or disable the
  *          various device drivers from your application. You may also use
  *          this file in order to override the device drivers default settings.
  *
- * @addtogroup HAL_CONF
+ * @addtogroup STM32L476RGNUCLEO64_HAL_CONF
  * @{
  */
 
-#ifndef HALCONF_H
-#define HALCONF_H
+#ifndef _HALCONF_H_
+#define _HALCONF_H_
 
 #define _CHIBIOS_HAL_CONF_
 #define _CHIBIOS_HAL_CONF_VER_6_0_
@@ -51,7 +53,7 @@
  * @brief   Enables the CAN subsystem.
  */
 #if !defined(HAL_USE_CAN) || defined(__DOXYGEN__)
-#define HAL_USE_CAN                         TRUE
+#define HAL_USE_CAN                         FALSE
 #endif
 
 /**
@@ -125,6 +127,13 @@
 #endif
 
 /**
+ * @brief   Enables the QEI subsystem.
+ */
+#if !defined(HAL_USE_QEI) || defined(__DOXYGEN__)
+#define HAL_USE_QEI                         FALSE
+#endif
+
+/**
  * @brief   Enables the QSPI subsystem.
  */
 #if !defined(HAL_USE_QSPI) || defined(__DOXYGEN__)
@@ -235,7 +244,7 @@
  * @brief   Sleep mode related APIs inclusion switch.
  */
 #if !defined(CAN_USE_SLEEP_MODE) || defined(__DOXYGEN__)
-#define CAN_USE_SLEEP_MODE                  FALSE
+#define CAN_USE_SLEEP_MODE                  TRUE
 #endif
 
 /**
@@ -313,7 +322,7 @@
  * @brief   Enables an event sources for incoming packets.
  */
 #if !defined(MAC_USE_EVENTS) || defined(__DOXYGEN__)
-#define MAC_USE_EVENTS                      FALSE
+#define MAC_USE_EVENTS                      TRUE
 #endif
 
 /*===========================================================================*/
@@ -329,7 +338,7 @@
  *          use a DMA channel and heavily loads the CPU.
  */
 #if !defined(MMC_NICE_WAITING) || defined(__DOXYGEN__)
-#define MMC_NICE_WAITING                    FALSE
+#define MMC_NICE_WAITING                    TRUE
 #endif
 
 /*===========================================================================*/
@@ -380,7 +389,7 @@
  *          lower priority, this may slow down the driver a bit however.
  */
 #if !defined(SDC_NICE_WAITING) || defined(__DOXYGEN__)
-#define SDC_NICE_WAITING                    FALSE
+#define SDC_NICE_WAITING                    TRUE
 #endif
 
 /**
@@ -407,7 +416,7 @@
  *          default configuration.
  */
 #if !defined(SERIAL_DEFAULT_BITRATE) || defined(__DOXYGEN__)
-#define SERIAL_DEFAULT_BITRATE              38400
+#define SERIAL_DEFAULT_BITRATE              115200
 #endif
 
 /**
@@ -513,6 +522,6 @@
 #define USB_USE_WAIT                        FALSE
 #endif
 
-#endif /* HALCONF_H */
+#endif /* _HALCONF_H_ */
 
 /** @} */